PlayerStandard.ye_olde_do_action_melee = PlayerStandard._do_action_melee
function PlayerStandard:_do_action_melee(t, input, skip_damage)
	local melee_entry = managers.blackmarket:equipped_melee_weapon()
	local twodee = tweak_data.blackmarket.melee_weapons[melee_entry].twodee or false
	if ( twodee ) then
		self:_do_action_melee_twodee( t, input, skip_damage )
	else
		self:ye_olde_do_action_melee( t, input, skip_damage )
	end
end

function PlayerStandard:_do_action_melee_twodee(t, input, skip_damage)
	self._state_data.meleeing = nil
	local melee_entry = managers.blackmarket:equipped_melee_weapon()
	local pre_calc_hit_ray = tweak_data.blackmarket.melee_weapons[melee_entry].hit_pre_calculation
	local melee_damage_delay = tweak_data.blackmarket.melee_weapons[melee_entry].melee_damage_delay or 0
	melee_damage_delay = math.min(melee_damage_delay, tweak_data.blackmarket.melee_weapons[melee_entry].repeat_expire_t)
	local primary = managers.blackmarket:equipped_primary()
	local primary_id = primary.weapon_id

	self._state_data.melee_expire_t = t + tweak_data.blackmarket.melee_weapons[melee_entry].expire_t
	self._state_data.melee_repeat_expire_t = t + math.min(tweak_data.blackmarket.melee_weapons[melee_entry].repeat_expire_t, tweak_data.blackmarket.melee_weapons[melee_entry].expire_t)

	if not skip_damage then
		self._state_data.melee_damage_delay_t = t + melee_damage_delay

		if pre_calc_hit_ray then
			self._state_data.melee_hit_ray = self:_calc_melee_hit_ray(t, 20) or true
		else
			self._state_data.melee_hit_ray = nil
		end
	end

	self._ext_network:send("sync_melee_discharge")

	if self._state_data.melee_charge_shake then
		self._ext_camera:shaker():stop(self._state_data.melee_charge_shake)

		self._state_data.melee_charge_shake = nil
	end

	self._melee_attack_var = 0

	local anim_attack_vars = tweak_data.blackmarket.melee_weapons[melee_entry].anim_attack_vars
	self._melee_attack_var = anim_attack_vars and math.random(#anim_attack_vars)

	self:_play_melee_sound(melee_entry, "hit_air", self._melee_attack_var)

	managers.hud._TwoDWeaponGUI:play_animation( melee_entry, "attack" )
end

PlayerStandard.ye_olde_start_action_melee = PlayerStandard._start_action_melee
function PlayerStandard:_start_action_melee(t, input, skip_damage)
	local melee_entry = managers.blackmarket:equipped_melee_weapon()
	local twodee = tweak_data.blackmarket.melee_weapons[melee_entry].twodee or false
	if ( twodee ) then
		self:_start_action_melee_twodee( t, input, skip_damage )
	else
		self:ye_olde_start_action_melee( t, input, skip_damage )
	end
end

function PlayerStandard:_start_action_melee_twodee(t, input, instant)
	self._equipped_unit:base():tweak_data_anim_stop("fire")
	self:_interupt_action_reload(t)
	self:_interupt_action_steelsight(t)
	self:_interupt_action_running(t)
	self:_interupt_action_charging_weapon(t)

	self._state_data.melee_charge_wanted = nil
	self._state_data.meleeing = true
	self._state_data.melee_start_t = nil
	local melee_entry = managers.blackmarket:equipped_melee_weapon()
	local primary = managers.blackmarket:equipped_primary()
	local primary_id = primary.weapon_id

	self:_stance_entered()

	local melee_entry = managers.blackmarket:equipped_melee_weapon()
	self._state_data.melee_global_value = tweak_data.blackmarket.melee_weapons[melee_entry].anim_global_param


	local attack_allowed_expire_t = tweak_data.blackmarket.melee_weapons[melee_entry].attack_allowed_expire_t or 0.15
	self._state_data.melee_attack_allowed_t = t + attack_allowed_expire_t

	self._ext_network:send("sync_melee_start")

	managers.hud._TwoDWeaponGUI:play_animation( melee_entry, "charge" )
end